<div class="grid-container mat-elevation-z8">
  <form [formGroup]="searchForm">
    <ng-select formControlName="criteria" [items]="criteria" [virtualScroll]="true" bindLabel="displayValue" [multiple]="true" placeholder="Search items"
      [searchFn]="searchCriterias" [addTag]="addTag" addTagText="Add keywords or ids (use the syntaxe id:<item-identifier> or users (user:<uuid>)">
      <ng-template ng-option-tmp let-item="item">
        <span [ngClass]="item._lvlClass" fxLayout="row" fxLayoutAlign="space-between center">
          <span>{{ item.displayValue }}</span>
          <span class="criterium-type" [ngClass]="item.type">{{ item.type }}</span>
        </span>
      </ng-template>
      <ng-template ng-label-tmp let-item="item" let-clear="clear">
        <span class="ng-value-content" [ngClass]="item.type">
          <span class="ng-value-icon left" (click)="clear(item);" aria-hidden="true">×</span>
          <span class="ng-value-label">{{ item.displayValue }}</span>
        </span>
      </ng-template>
    </ng-select>
  </form>
  <ng-scrollbar track="all">
    <div class="items-container" gdColumns="1fr 1fr" gdColumns.gt-sm="1fr 1fr 1fr" gdColumns.gt-md="1fr 1fr 1fr 1fr" gdColumns.gt-lg="repeat(5, 1fr)" gdRows="auto" gdGap="8px">
      <ng-container *ngIf="items.length > 0; else emptyResult">
        <mat-card *ngFor="let item of items; let i = index">
          <div mat-card-image>
            <img [attr.src]="item.variants[0].photos[0]" alt="">
          </div>
          <div class="mark-as-incomplete" *ngIf="item.incomplete">
            <span>Incomplete</span>
          </div>
          <div class="mark-as-draft" *ngIf="item.status === 'draft' || item.draft !== undefined">
            <span>Draft</span><br>
            <ng-container *ngIf="item.status === 'draft'">new</ng-container>
            <ng-container *ngIf="item.status === 'draft' && item.draft !== undefined">, </ng-container>
            <ng-container *ngIf="item.draft !== undefined">update</ng-container>
          </div>
          <mat-card-actions>
            <button mat-icon-button aria-label="Edit" (click)="edit(item, i)">
              <mat-icon>edit</mat-icon>
            </button>
          </mat-card-actions>
        </mat-card>
      </ng-container>
      <ng-template #emptyResult>
        No items found.
      </ng-template>
    </div>
  </ng-scrollbar>
  <mat-paginator [length]="resultsLength" [pageSizeOptions]="pageSizeOptions" [pageSize]="pageSize" (page)="onPageChange()"></mat-paginator>
</div>

<ng-template #itemFormModal let-data let-ref="dialogRef">
  <div mat-dialog-title>
    <h2>Edit "<span>{{ data.item._id }}</span>"</h2>
    <div fxLayout="row" fxLayoutAlign="space-between">
      <p>Owner: <span>{{ data.item.owner }}</span></p>
      <button type="button" mat-button mat-dialog-close (click)="addUserCriteria(data.item.owner)">See all items</button>
    </div>
  </div>
  <form [formGroup]="data.form" (ngSubmit)="update(data, ref)" class="edit-form">
    <mat-dialog-content fxLayout="column" fxLayoutGap="8px">
      <ng-select appInput placeholder="Brand *" formControlName="brand" [items]="brands" bindLabel="name" [searchFn]="searchFn" [addTag]="addCustomBrand" addTagText="Add brand"
        required>
        <ng-template ng-option-tmp let-item="item">
          <span *ngIf="!item.shortname">{{ item.name }}</span>
          <span *ngIf="item.shortname">{{ item.name }} ({{ item.shortname }})</span>
        </ng-template>
        <ng-template ng-label-tmp let-item="item" let-clear="clear">
          <span class="ng-value-content">
            <span class="ng-value-label">
              {{ item.name }}
            </span>
          </span>
        </ng-template>
      </ng-select>
      <mat-form-field>
        <mat-label>Collection</mat-label>
        <input matInput formControlName="collectionn">
      </mat-form-field>
      <ng-select appInput placeholder="Category *" formControlName="category" [items]="categories" [searchFn]="searchFn" bindLabel="name" required>
        <ng-template ng-option-tmp let-item="item">
          <span [ngClass]="item._lvlClass">
            <span *ngIf="!item.shortname">{{ item.name }}</span>
            <span *ngIf="item.shortname">{{ item.name }} ({{ item.shortname }})</span>
          </span>
        </ng-template>
        <ng-template ng-label-tmp let-item="item" let-clear="clear">
          <span class="ng-value-content">
            <span class="ng-value-label">
              {{ item.name }}
            </span>
          </span>
        </ng-template>
      </ng-select>
      <ng-select appInput placeholder="Features" formControlName="features" [items]="(features | availableFeatures:data.form.controls.category | async) || []" [multiple]="true"
        bindLabel="name" dropdownPosition="top">
        <ng-template ng-notfound-tmp>
          <div class="ng-option ng-option-disabled" [innerHTML]="'No feature found for this category'"></div>
        </ng-template>
        <ng-template ng-option-tmp let-item="item">
          <span>{{ item.name }}</span>
        </ng-template>
        <ng-template ng-label-tmp let-item="item" let-clear="clear">
          <span class="ng-value-content">
            <span class="ng-value-label">
              {{ item.name }}
            </span>
          </span>
        </ng-template>
      </ng-select>
      <div formArrayName="variants" fxLayout="column" fxLayoutAlign="start start" fxLayoutGap="16px">
        <mat-accordion fxFill>
          <mat-expansion-panel *ngFor="let variant of data.form.controls.variants.controls; let i = index" [formGroupName]="i">
            <mat-expansion-panel-header>
              <mat-panel-title>Colorway #{{ i + 1 }}</mat-panel-title>
            </mat-expansion-panel-header>
            <div>
              <ng-select placeholder="Colors" formControlName="colors" [items]="colors" [virtualScroll]="true" [multiple]="true" [maxSelectedItems]="2" bindLabel="name" required>
                <ng-template ng-option-tmp let-item="item">
                  {{ item.name }}
                  <span class="color-display" aria-hidden="true" [ngStyle]="{background: item.hex}"></span>
                </ng-template>
                <ng-template ng-label-tmp let-item="item" let-clear="clear">
                  <span class="ng-value-content">
                    <span class="ng-value-icon left" (click)="clear(item);" aria-hidden="true">×</span>
                    <span class="ng-value-label">
                      {{ item.name }}
                      <span class="color-display" aria-hidden="true" [ngStyle]="{background: item.hex}"></span>
                    </span>
                  </span>
                </ng-template>
              </ng-select>
              <div class="photos-container" formArrayName="photos" fxLayout="row wrap" fxLayoutGap="8px">
                <ng-container *ngFor="let photo of variant.controls.photos.controls; let j = index; let isLast = last; let total = count">
                  <mel-upload-image (imageChange)="ensureEmptyPhoto(variant)" [key]="data.item._id" [formControlName]="j" [fxFlex]="'0 0 ' + melUploadImage.width + 'px'"
                    #melUploadImage="melUploadImage" [required]="j === 0">
                    <div class="actions" *ngIf="melUploadImage.value && !(j === 0 && total === 2)">
                      <button mat-stroked-button color="warn" type="button" (click)="removePhoto(variant, j)">
                        <span>Remove</span>
                      </button>
                    </div>
                  </mel-upload-image>
                </ng-container>
              </div>
              <button type="button" mat-stroked-button color="warn" (click)="removeVariant(data.form.controls.variants, i)">Remove the colorway</button>
            </div>
          </mat-expansion-panel>
        </mat-accordion>
        <button type="button" mat-stroked-button (click)="addVariant(data.form.controls.variants)">Add a new colorway</button>
      </div>
      <mat-form-field>
        <mat-label>Year of release</mat-label>
        <input matInput formControlName="year">
      </mat-form-field>
      <mat-form-field>
        <mat-label>Original name</mat-label>
        <input matInput formControlName="japanese">
      </mat-form-field>
      <mat-form-field>
        <mat-label>Measurments</mat-label>
        <textarea matInput formControlName="measurments" rows="5"></textarea>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Estimated price</mat-label>
        <input type="number" matInput formControlName="estimatedPrice">
      </mat-form-field>
      <ng-select appInput placeholder="Keywords" formControlName="keywords" [multiple]="true" [items]="[]" [addTag]="true" [addTagText]="'ITEM.ADD_TAG.KEYWORDS' | translate"
        [selectOnTab]="true">
        <ng-template ng-notfound-tmp>
          <div class="ng-option ng-option-disabled" [innerHTML]="'ITEM.NOT_FOUND_TEXT.KEYWORDS' | translate"></div>
        </ng-template>
        <ng-template ng-label-tmp let-item="item" let-clear="clear">
          <span class="ng-value-content">
            <span class="ng-value-icon left" (click)="clear(item);" aria-hidden="true">×</span>
            <span class="ng-value-label">
              {{ item }}
            </span>
          </span>
        </ng-template>
      </ng-select>
      <ng-select placeholder="Substyle(s) / Theme(s)" appInput formControlName="substyles" [multiple]="true" [items]="substyles" [addTag]="true"
        [addTagText]="'ITEM.ADD_TAG.SUBSTYLES' | translate" [selectOnTab]="true">
        <ng-template ng-label-tmp let-item="item" let-clear="clear">
          <span class="ng-value-content">
            <span class="ng-value-icon left" (click)="clear(item);" aria-hidden="true">×</span>
            <span class="ng-value-label">
              {{ item }}
            </span>
          </span>
        </ng-template>
      </ng-select>
    </mat-dialog-content>
    <mat-dialog-actions fxLayout="row">
      <button type="button" mat-button mat-dialog-close>Cancel</button>
      <button type="submit" mat-raised-button color="primary" [disabled]="data.form.pristine || data.form.invalid">
        Update
      </button>
      <div fxFlex="1 1 0" aria-hidden="true"></div>
      <button type="button" mat-raised-button color="accent" *ngIf="data.form.value.status === 'draft' || data.item.draft !== undefined" (click)="validateDraft(data, ref)">
        Approve the draft
      </button>
      <button type="button" mat-stroked-button color="primary" *ngIf="!data.form.value.incomplete" (click)="markAsIncomplete(data, ref)">
        Mark as incomplete
      </button>
      <button type="button" mat-stroked-button color="primary" *ngIf="data.form.value.incomplete" (click)="unmarkedAsIncomplete(data, ref)">
        Unmark as incomplete
      </button>
    </mat-dialog-actions>
  </form>
</ng-template>
